<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class ReceiveCommand
 * @package FiloBlu\Flow\Console\Command
 */
class ReceiveCommand extends Command
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $state;

    /**
     * ReceiveCommand constructor.
     * @param \Magento\Framework\App\State $state
     */
    public function __construct(
        \Magento\Framework\App\State $state
    ) {
        $this->state = $state;
        return parent::__construct();
    }

    /**
     *
     */
    protected function configure()
    {
        $this->setName('flow:receive')->setDescription('Receive files/data from remote source');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int|null|void
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        try {
            $this->state->setAreaCode('adminhtml');
        } catch (\Exception $ex) {
            $output->writeln("Areacode was already set, skipping!");
        }

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $this->cronModel = $objectManager->create(\FiloBlu\Flow\Cron\Fetch::class);
        $this->cronModel->receive();

        $output->writeln('<info>Receive executed !</info>');
    }

}